// Ansteuerung eines HD44780 kompatiblen LCD im 4-Bit-Interfacemodus
// http://www.mikrocontroller.net/articles/AVR-GCC-Tutorial
//
#include "..\cpu_speed.h"

#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <stdlib.h>
#include <stdarg.h>
#include <ctype.h>
#include <string.h>
#include <avr/io.h>
#include <avr/eeprom.h>

void lcd_data(unsigned char temp1);
void lcd_string(char *data);
void lcd_command(unsigned char temp1);
void lcd_enable(void);
void lcd_init(void);
void lcd_home(void);
void lcd_clear(void);
void set_cursor(uint8_t x, uint8_t y);
void lcd_eep_string(const unsigned char *data);

void lcd_BackLightOn();
void lcd_BackLightOff();

//void lcd_write_char(char c);
void lcd_write_P (const char *Buffer,...);
#define lcd_write(format, args...)   lcd_write_P(PSTR(format) , ## args)
 
// LCD Befehle
#define CLEAR_DISPLAY 0x01
#define CURSOR_HOME   0x02
 
// Pinbelegung fr das LCD, an verwendete Pins anpassen
#define LCD_PORT      PORTA
#define LCD_DDR       DDRA
#define LCD_RS        PA0
#define LCD_EN        PA1
#define LCD_LIGHT     PA6
#define LCD_DB4       PA2
#define LCD_DB5       PA3
#define LCD_DB6       PA4
#define LCD_DB7       PA5


// Pin#-LCD  Bezeichnung-LCD    Pin-C 
//  1             Vss             GND 
//  2             Vcc             5V
//  3             Vee (Kontrast)  Poti (am Pin Werte von 0 - ca. 1,25V ntig)
//  4             RS              PD0 am AVR 
//  5             RW              GND 
//  6             E               PA1 am AVR 
//  7             DB0             offen 
//  8             DB1             offen 
//  9             DB2             offen 
// 10             DB3             offen 
// 11             DB4             PD2 am AVR 
// 12             DB5             PD3 am AVR 
// 13             DB6             PD4 am AVR 
// 14             DB7             PD5 am AVR 
